################
# Animat.py    #
# G.Desmeulles #
# 23/04/2013   #
# 27/07/2022   #
# S2-IPI       #
################
import sys
import os

#le module animat gere le type abstrait de donnee animat
#un animat est un objet qui se deplace dans le terminal 


class Animat: pass

def create(color,direction,x,y,speed):
	
	#creation animat
	animat=Animat()
	animat.color=color
	animat.direction=direction
	animat.x=x
	animat.y=y
	animat.speed=speed
		
	return animat

def show(a) : 
	
	#on se place a la position de l animat dans le terminal
	x=str(int(a.x))
	y=str(int(a.y))
	txt="\033["+y+";"+x+"H"
	sys.stdout.write(txt)
	
	#couleur fond noire
	sys.stdout.write("\033[40m")
	
	#couleur animat
	c=a.color
	txt="\033[3"+str(c%7+1)+"m"
	sys.stdout.write(txt)

	#affichage de l animat
	sys.stdout.write("O\n")
	
def computeNextPosition(dt,a):
	#calcul de la position future de l animat en fonction du pas de temps
	x=a.x
	y=a.y
	if a.direction=="up":
		y=(a.y-(a.speed*dt))
	elif a.direction=="right":
		x=(a.x+(a.speed*dt))
	elif a.direction=="down":
		y=(a.y+(a.speed*dt))
	elif a.direction=="left":
		x=(a.x-(a.speed*dt))
	return x,y

def setPosition(a,x,y):
	a.x=x
	a.y=y
	
def changeColor(a):
	a.color=a.color+1

def changeDirection(a):
	if a.direction=="up":
		a.direction="right"
	elif a.direction=="right":
		a.direction="down"
	elif a.direction=="down":
		a.direction="left"
	elif a.direction=="left":
		a.direction="up"
